Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.spi
Class RoutingTableImpl

    java.lang.Object
      org.jivesoftware.openfire.container.BasicModule
          org.jivesoftware.openfire.spi.RoutingTableImpl

All Implemented Interfaces:
  ClusterEventListener, Module, RoutingTable

    public class RoutingTableImpl

extends BasicModule
implements RoutingTable, ClusterEventListener

Routing table that stores routes to client sessions, outgoing server sessions and components. As soon as a user authenticates with the server its client session will be added to the routing table. Whenever the client session becomes available or unavailable the routing table will be updated too.

When running inside of a cluster the routing table will also keep references to routes hosted in other cluster nodes. A `RemotePacketRouter` will be use to route packets to routes hosted in other cluster nodes.

Failure to route a packet will end up sending `IQRouter.routingFailed(JID, Packet)`, `MessageRouter.routingFailed(JID, Packet)` or `PresenceRouter.routingFailed(JID, Packet)` depending on the packet type that tried to be sent.

Author:
  Gaston Dombiak

Field Summary
`static String` | `ANONYMOUS_C2S_CACHE_NAME`
`static String` | `C2S_CACHE_NAME`
`static String` | `C2S_SESSION_NAME`
`static String` | `COMPONENT_CACHE_NAME`
`static String` | `S2S_CACHE_NAME`

Constructor Summary
`RoutingTableImpl()`

Method Summary
`boolean` | `addClientRoute(org.xmpp.packet.JID route, LocalClientSession destination)` Adds a route to the routing table for the specified client session.
`void` | `addComponentRoute(org.xmpp.packet.JID route, RoutableChannelHandler destination)` Adds a route to the routing table for the specified internal or external component.
`void` | `addServerRoute(org.xmpp.packet.JID route, LocalOutgoingServerSession destination)` Adds a route to the routing table for the specified outoing server session.
`void` | `broadcastPacket(org.xmpp.packet.Message packet, boolean onlyLocal)` Broadcasts the specified message to connected client sessions to the local node or across the cluster.
`ClientSession` | `getClientRoute(org.xmpp.packet.JID jid)` Returns the client session associated to the specified XMPP address or `null` if none was found.
`Collection<ClientSession>` | `getClientsRoutes(boolean onlyLocal)` Returns collection of client sessions authenticated with the server.
`Collection<String>` | `getComponentsDomains()` Returns domains of components hosted by the server.
`RemotePacketRouter` | `getRemotePacketRouter()` Returns the `RemotePacketRouter` to use for deliverying packets to entities hosted in remote nodes of the cluster or `null` if none was set.
`List<org.xmpp.packet.JID>` | `getRoutes(org.xmpp.packet.JID route, org.xmpp.packet.JID requester)` Returns the list of routes associated to the specified route address.
`Collection<String>` | `getServerHostnames()` Returns a collection with the hostnames of the remote servers that currently may receive packets sent from this server.
`OutgoingServerSession` | `getServerRoute(org.xmpp.packet.JID jid)` Returns the outgoing server session associated to the specified XMPP address or `null` if none was found.
`int` | `getServerSessionsCount()` Returns the number of outgoing server sessions hosted in this JVM.
`boolean` | `hasClientRoute(org.xmpp.packet.JID jid)` Returns true if a registered user or anonymous user with the specified full JID is currently logged.
`boolean` | `hasComponentRoute(org.xmpp.packet.JID jid)` Returns true if an internal or external component is hosting the specified address.
`boolean` | `hasServerRoute(org.xmpp.packet.JID jid)` Returns true if an outgoing server session exists to the specified remote server.
`void` | `initialize(XMPPServer server)` Initializes the basic module.
`boolean` | `isAnonymousRoute(org.xmpp.packet.JID jid)` Returns true if an anonymous user with the specified full JID is currently logged.
`boolean` | `isLocalRoute(org.xmpp.packet.JID jid)` Returns true if the specified address belongs to a route that is hosted by this JVM.
`void` | `joinedCluster()` Notification event indicating that this JVM is now part of a cluster.
`void` | `joinedCluster(byte[] nodeID)` Notification event indicating that another JVM is now part of a cluster.
`void` | `leftCluster()` Notification event indicating that this JVM is no longer part of the cluster.
`void` | `leftCluster(byte[] nodeID)` Notification event indicating that another JVM is no longer part of the cluster.
`void` | `markedAsSeniorClusterMember()` Notification event indicating that this JVM is now the senior cluster member.
`boolean` | `removeClientRoute(org.xmpp.packet.JID route)` Returns true if a route of a client session has been successfully removed.
`boolean` | `removeComponentRoute(org.xmpp.packet.JID route)` Returns true if a route of a component has been successfully removed.
`boolean` | `removeServerRoute(org.xmpp.packet.JID route)` Returns true if a route to an outoing server has been successfully removed.
`void` | `routePacket(org.xmpp.packet.JID jid, org.xmpp.packet.Packet packet, boolean fromServer)` Routes a packet to the specified address.
`void` | `setRemotePacketRouter(RemotePacketRouter remotePacketRouter)` Sets the `RemotePacketRouter` to use for deliverying packets to entities hosted in remote nodes of the cluster.
`void` | `start()` Starts the basic module.
`void` | `stop()` Stops the basic module.

Methods inherited from class org.jivesoftware.openfire.container.BasicModule
`destroy, getName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### C2S_CACHE_NAME

    public static final String C2S_CACHE_NAME

See Also:
  Constant Field Values

### ANONYMOUS_C2S_CACHE_NAME

    public static final String ANONYMOUS_C2S_CACHE_NAME

See Also:
  Constant Field Values

### S2S_CACHE_NAME

    public static final String S2S_CACHE_NAME

See Also:
  Constant Field Values

### COMPONENT_CACHE_NAME

    public static final String COMPONENT_CACHE_NAME

See Also:
  Constant Field Values

### C2S_SESSION_NAME

    public static final String C2S_SESSION_NAME

See Also:
  Constant Field Values

Constructor Detail

### RoutingTableImpl

    public RoutingTableImpl()

Method Detail

### addServerRoute

    public void addServerRoute(org.xmpp.packet.JID route,
                               LocalOutgoingServerSession destination)

  Description copied from interface: `RoutingTable`
  Adds a route to the routing table for the specified outoing server session. When running inside of a cluster this message `must` be sent from the cluster node that is actually holding the physical connectoin to the remote server.

  Specified by:
    `addServerRoute` in interface `RoutingTable`
  Parameters:
    `route` - the address associated to the route.
    `destination` - the outgoing server session.

### addComponentRoute

    public void addComponentRoute(org.xmpp.packet.JID route,
                                  RoutableChannelHandler destination)

  Description copied from interface: `RoutingTable`
  Adds a route to the routing table for the specified internal or external component.

  When running inside of a cluster this message `must` be sent from the cluster node that is actually hosting the component. The component may be available in all or some of cluster nodes. The routing table will keep track of all nodes hosting the component.

  Specified by:
    `addComponentRoute` in interface `RoutingTable`
  Parameters:
    `route` - the address associated to the route.
    `destination` - the component.

### addClientRoute

    public boolean addClientRoute(org.xmpp.packet.JID route,
                                  LocalClientSession destination)

  Description copied from interface: `RoutingTable`
  Adds a route to the routing table for the specified client session. The client session will be added as soon as the user has finished authenticating with the server. Moreover, when the user becomes available or unavailable then the routing table will get updated again. When running inside of a cluster this message `must` be sent from the cluster node that is actually holding the client session.

  Specified by:
    `addClientRoute` in interface `RoutingTable`
  Parameters:
    `route` - the address associated to the route.
    `destination` - the client session.
  Returns:
    true if route was added to the table or false if already present.

### broadcastPacket

    public void broadcastPacket(org.xmpp.packet.Message packet,
                                boolean onlyLocal)

  Description copied from interface: `RoutingTable`
  Broadcasts the specified message to connected client sessions to the local node or across the cluster. Both available and unavailable client sessions will receive the message.

  Specified by:
    `broadcastPacket` in interface `RoutingTable`
  Parameters:
    `packet` - the message to broadcast.
    `onlyLocal` - true if only client sessions connecte to the local JVM will get the message.

### routePacket

    public void routePacket(org.xmpp.packet.JID jid,
                            org.xmpp.packet.Packet packet,
                            boolean fromServer)
                     throws PacketException

  Description copied from interface: `RoutingTable`
  Routes a packet to the specified address. The packet destination can be a user on the local server, a component, or a foreign server.

  When routing a packet to a remote server then a new outgoing connection will be created to the remote server if none was found and the packet will be delivered. If an existing outgoing connection already exists then it will be used for delivering the packet. Moreover, when running inside of a cluster the node that has the actual outgoing connection will be requested to deliver the requested packet.

  Packets routed to components will only be sent if the internal or external component is connected to the server. Moreover, when running inside of a cluster the node that is hosting the component will be requested to deliver the requested packet. It will be first checked if the component is available in this JVM and if not then the first cluster node found hosting the component will be used.

  Packets routed to users will be delivered if the user is connected to the server. Depending on the packet type and the sender of the packet only available or all user sessions could be considered. For instance, `Messages` and `Presences` are only sent to available client sessions whilst `IQs` originated to the server can be sent to available or unavailable sessions. When running inside of a cluster the node that is hosting the user session will be requested to deliver the requested packet.

  Specified by:
    `routePacket` in interface `RoutingTable`
  Parameters:
    `jid` - the recipient of the packet to route.
    `packet` - the packet to route.
    `fromServer` - true if the packet was created by the server. This packets should always be delivered
  Throws:
    `PacketException` - thrown if the packet is malformed (results in the sender's session being shutdown).

### getClientRoute

    public ClientSession getClientRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns the client session associated to the specified XMPP address or `null` if none was found. When running inside of a cluster and a remote node is hosting the client session then a session surrage will be returned.

  Specified by:
    `getClientRoute` in interface `RoutingTable`
  Parameters:
    `jid` - the address of the session.
  Returns:
    the client session associated to the specified XMPP address or null if none was found.

### getClientsRoutes

    public Collection<ClientSession> getClientsRoutes(boolean onlyLocal)

  Description copied from interface: `RoutingTable`
  Returns collection of client sessions authenticated with the server. When running inside of a cluster the returned sessions will include sessions connected to this JVM and also other cluster nodes. TODO Prevent usage of this message and change original requirement to avoid having to load all sessions. TODO This may not scale when hosting millions of sessions.

  Specified by:
    `getClientsRoutes` in interface `RoutingTable`
  Parameters:
    `onlyLocal` - true if only client sessions connected to this JVM must be considered.
  Returns:
    collection of client sessions authenticated with the server.

### getServerRoute

    public OutgoingServerSession getServerRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns the outgoing server session associated to the specified XMPP address or `null` if none was found. When running inside of a cluster and a remote node is hosting the session then a session surrage will be returned.

  Specified by:
    `getServerRoute` in interface `RoutingTable`
  Parameters:
    `jid` - the address of the session.
  Returns:
    the outgoing server session associated to the specified XMPP address or null if none was found.

### getServerHostnames

    public Collection<String> getServerHostnames()

  Description copied from interface: `RoutingTable`
  Returns a collection with the hostnames of the remote servers that currently may receive packets sent from this server.

  Specified by:
    `getServerHostnames` in interface `RoutingTable`
  Returns:
    a collection with the hostnames of the remote servers that currently may receive packets sent from this server.

### getServerSessionsCount

    public int getServerSessionsCount()

  Description copied from interface: `RoutingTable`
  Returns the number of outgoing server sessions hosted in this JVM. When runing inside of a cluster you will need to get this value for each cluster node to learn the total number of outgoing server sessions.

  Specified by:
    `getServerSessionsCount` in interface `RoutingTable`
  Returns:
    the number of outgoing server sessions hosted in this JVM.

### getComponentsDomains

    public Collection<String> getComponentsDomains()

  Description copied from interface: `RoutingTable`
  Returns domains of components hosted by the server. When running in a cluster, domains of components running in any node will be returned.

  Specified by:
    `getComponentsDomains` in interface `RoutingTable`
  Returns:
    domains of components hosted by the server.

### hasClientRoute

    public boolean hasClientRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns true if a registered user or anonymous user with the specified full JID is currently logged. When running inside of a cluster a true value will be returned as long as the user is connected to any cluster node. // TODO Should we care about available or not available????

  Specified by:
    `hasClientRoute` in interface `RoutingTable`
  Parameters:
    `jid` - the full JID of the user.
  Returns:
    true if a registered user or anonymous user with the specified full JID is currently logged.

### isAnonymousRoute

    public boolean isAnonymousRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns true if an anonymous user with the specified full JID is currently logged. When running inside of a cluster a true value will be returned as long as the user is connected to any cluster node.

  Specified by:
    `isAnonymousRoute` in interface `RoutingTable`
  Parameters:
    `jid` - the full JID of the anonymous user.
  Returns:
    true if an anonymous user with the specified full JID is currently logged.

### isLocalRoute

    public boolean isLocalRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns true if the specified address belongs to a route that is hosted by this JVM. When running inside of a cluster each cluster node will host routes to local resources. A false value could either mean that the route is not hosted by this JVM but other cluster node or that there is no route to the specified address. Use `XMPPServer.isLocal(org.xmpp.packet.JID)` to figure out if the address belongs to tge domain hosted by this server.

  Specified by:
    `isLocalRoute` in interface `RoutingTable`
  Parameters:
    `jid` - the address of the route.
  Returns:
    true if the specified address belongs to a route that is hosted by this JVM.

### hasServerRoute

    public boolean hasServerRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns true if an outgoing server session exists to the specified remote server. The JID can be a full JID or a bare JID since only the domain of the specified address will be used to look up the route.

  When running inside of a cluster the look up will be done in all the cluster. So as long as a node has a connection to the remote server a true value will be returned.

  Specified by:
    `hasServerRoute` in interface `RoutingTable`
  Parameters:
    `jid` - JID that specifies the remote server address.
  Returns:
    true if an outgoing server session exists to the specified remote server.

### hasComponentRoute

    public boolean hasComponentRoute(org.xmpp.packet.JID jid)

  Description copied from interface: `RoutingTable`
  Returns true if an internal or external component is hosting the specified address. The JID can be a full JID or a bare JID since only the domain of the specified address will be used to look up the route.

  When running inside of a cluster the look up will be done in all the cluster. So as long as a node is hosting the component a true value will be returned.

  Specified by:
    `hasComponentRoute` in interface `RoutingTable`
  Parameters:
    `jid` - JID that specifies the component address.
  Returns:
    true if an internal or external component is hosting the specified address.

### getRoutes

    public List<org.xmpp.packet.JID> getRoutes(org.xmpp.packet.JID route,
                                               org.xmpp.packet.JID requester)

  Description copied from interface: `RoutingTable`
  Returns the list of routes associated to the specified route address. When asking for routes to a remote server then the requested JID will be included as the only value of the returned collection. It is indifferent if an outgoing session to the specified remote server exists or not.

  When asking for routes to client sessions the specified route address could either be a full JID of a bare JID. In the case of a full JID, a single element will be included in the answer in case the specified full JID exists or an empty collection if the full JID does not exist. Moreover, when passing a bare JID a list of full JIDs will be returned for each available resource associated to the bare JID. In any case, only JIDs of `available` client sessions are returned. However, there is an exception with directed presences. Unavailable routes may be returned if and only if the owner of the route sent a directed presence to the requester thus becoming available to the requester. If requester is `null` then only available resources are considered.

  When asking for routes to components a single element will be returned in the answer only if an internal or external component is found for the specified route address. If no component was found then an empty collection will be returned.

  Specified by:
    `getRoutes` in interface `RoutingTable`
  Parameters:
    `route` - The address we want a route to.
    `requester` - The address of the entity requesting the routes or null if we don't care about directed presences.
  Returns:
    list of routes associated to the specified route address.

### removeClientRoute

    public boolean removeClientRoute(org.xmpp.packet.JID route)

  Description copied from interface: `RoutingTable`
  Returns true if a route of a client session has been successfully removed. When running inside of a cluster this message `must` be sent from the cluster node that is actually hosting the client session.

  Specified by:
    `removeClientRoute` in interface `RoutingTable`
  Parameters:
    `route` - the route to remove.
  Returns:
    true if a route of a client session has been successfully removed.

### removeServerRoute

    public boolean removeServerRoute(org.xmpp.packet.JID route)

  Description copied from interface: `RoutingTable`
  Returns true if a route to an outoing server has been successfully removed. When running inside of a cluster this message `must` be sent from the cluster node that is actually holding the physical connectoin to the remote server.

  Specified by:
    `removeServerRoute` in interface `RoutingTable`
  Parameters:
    `route` - the route to remove.
  Returns:
    true if the route was successfully removed.

### removeComponentRoute

    public boolean removeComponentRoute(org.xmpp.packet.JID route)

  Description copied from interface: `RoutingTable`
  Returns true if a route of a component has been successfully removed. Both internal and external components have a route in the table. When running inside of a cluster this message `must` be sent from the cluster node that is actually hosting the component.

  Specified by:
    `removeComponentRoute` in interface `RoutingTable`
  Parameters:
    `route` - the route to remove.
  Returns:
    true if a route of a component has been successfully removed.

### setRemotePacketRouter

    public void setRemotePacketRouter(RemotePacketRouter remotePacketRouter)

  Description copied from interface: `RoutingTable`
  Sets the `RemotePacketRouter` to use for deliverying packets to entities hosted in remote nodes of the cluster.

  Specified by:
    `setRemotePacketRouter` in interface `RoutingTable`
  Parameters:
    `remotePacketRouter` - the RemotePacketRouter to use for deliverying packets to entities hosted in remote nodes of the cluster.

### getRemotePacketRouter

    public RemotePacketRouter getRemotePacketRouter()

  Description copied from interface: `RoutingTable`
  Returns the `RemotePacketRouter` to use for deliverying packets to entities hosted in remote nodes of the cluster or `null` if none was set.

  Specified by:
    `getRemotePacketRouter` in interface `RoutingTable`
  Returns:
    the RemotePacketRouter to use for deliverying packets to entities hosted in remote nodes of the cluster.

### initialize

    public void initialize(XMPPServer server)

  Description copied from class: `BasicModule`

  Initializes the basic module.

  Inheriting classes that choose to override this method MUST call this initialize() method before accessing BasicModule resources.

  Specified by:
    `initialize` in interface `Module`
  Overrides:
    `initialize` in class `BasicModule`
  Parameters:
    `server` - the server hosting this module.

### start

    public void start()
               throws IllegalStateException

  Description copied from class: `BasicModule`

  Starts the basic module.

  Inheriting classes that choose to override this method MUST call this start() method before accessing BasicModule resources.

  Specified by:
    `start` in interface `Module`
  Overrides:
    `start` in class `BasicModule`
  Throws:
    `IllegalStateException` - If start is called before initialize successfully returns

### stop

    public void stop()

  Description copied from class: `BasicModule`

  Stops the basic module.

  Inheriting classes that choose to override this method MUST call this stop() method before accessing BasicModule resources.

  Specified by:
    `stop` in interface `Module`
  Overrides:
    `stop` in class `BasicModule`

### joinedCluster

    public void joinedCluster()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is now part of a cluster. At this point the `XMPPServer.getNodeID()` holds the new nodeID value.

  When joining the cluster as the senior cluster member the `ClusterEventListener.markedAsSeniorClusterMember()` event will be sent right after this event.

  At this point the CacheFactory holds clustered caches. That means that modifications to the caches will be reflected in the cluster. The clustered caches were just obtained from the cluster and no local cached data was automatically moved.

  Specified by:
    `joinedCluster` in interface `ClusterEventListener`

### joinedCluster

    public void joinedCluster(byte[] nodeID)

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that another JVM is now part of a cluster.

  At this point the CacheFactory of the new node holds clustered caches. That means that modifications to the caches of this JVM will be reflected in the cluster and in particular in the new node.

  Specified by:
    `joinedCluster` in interface `ClusterEventListener`
  Parameters:
    `nodeID` - ID of the node that joined the cluster.

### leftCluster

    public void leftCluster()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is no longer part of the cluster. This could happen when disabling clustering support, removing the enterprise plugin that provides clustering support or connection to cluster got lost.

  Moreover, if we were in a "split brain" scenario (ie. separated cluster islands) and the island were this JVM belonged was marked as "old" then all nodes of that island will get the `left cluster event` and `joined cluster events`. That means that caches will be reset and thus will need to be repopulated again with fresh data from this JVM. This also includes the case where this JVM was the senior cluster member and when the islands met again then this JVM stopped being the senior member.

  At this point the CacheFactory holds local caches. That means that modifications to the caches will only affect this JVM.

  Specified by:
    `leftCluster` in interface `ClusterEventListener`

### leftCluster

    public void leftCluster(byte[] nodeID)

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that another JVM is no longer part of the cluster. This could happen when disabling clustering support, removing the enterprise plugin that provides clustering support or connection to cluster got lost.

  Moreover, if we were in a "split brain" scenario (ie. separated cluster islands) and the island were the other JVM belonged was marked as "old" then all nodes of that island will get the `left cluster event` and `joined cluster events`. That means that caches will be reset and thus will need to be repopulated again with fresh data from this JVM. This also includes the case where the other JVM was the senior cluster member and when the islands met again then the other JVM stopped being the senior member.

  At this point the CacheFactory of the leaving node holds local caches. That means that modifications to the caches of this JVM will not affect the leaving node but other cluster members.

  Specified by:
    `leftCluster` in interface `ClusterEventListener`
  Parameters:
    `nodeID` - ID of the node that is left the cluster.

### markedAsSeniorClusterMember

    public void markedAsSeniorClusterMember()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is now the senior cluster member. This could either happen when initially joining the cluster or when the senior cluster member node left the cluster and this JVM was marked as the new senior cluster member.

  Moreover, in the case of a "split brain" scenario (ie. separated cluster islands) each island will have its own senior cluster member. However, when the islands meet again there could only be one senior cluster member so one of the senior cluster members will stop playing that role. When that happens the JVM no longer playing that role will receive the `ClusterEventListener.leftCluster()` and `ClusterEventListener.joinedCluster()` events.

  Specified by:
    `markedAsSeniorClusterMember` in interface `ClusterEventListener`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.